#ifndef _miniframe_h_
#define _miniframe_h_

#include <sys/types.h>
#include <mywchar.h>
#include "obj.h"

typedef struct MiniFrame {

	Display *dpy;
	Window win;
	GC gc;

	int width;
	int formatted_width;
	int formatted_height;

	/* frameinfo */
	int after_lf;
	int cur_x;
	int cur_y;
	int max_ascent;
	int max_descent;
	
	OC *oc;
	u_long foreground;

	HTMLObjList obj;
	HTMLObjList line;

	/* data */
	wchar_t *wstr;

} MiniFrame;

MiniFrame *miniframe_new(Display *dpy, Window win,
						 FontInfoTableList fitl, 
						 FontNameTableList fntl,
						 int fonttype, int fontsize,
						 u_int width);
void miniframe_delete(MiniFrame *mf);
void miniframe_open(MiniFrame *mf, char *str);
void miniframe_expose_region(MiniFrame *mf, int off_x, int off_y, Region reg);

#endif
