typedef struct TagInfo {
	char *name;
	TAGS id;
} TagInfo;

static int
check_taginfo(void *p, char *str)
{
	TagInfo *t = p;
	return strcmp(t->name, str);
}

#define TAGINFO(tag) #tag,TAG_ ## tag
TagInfo taginfo_table[] = {
	{ TAGINFO(html) },
	{ TAGINFO(head) },
	{ TAGINFO(body) },
	{ TAGINFO(title) },
	{ TAGINFO(base)  },
	{ TAGINFO(meta)  },
	{ TAGINFO(basefont) },
	{ TAGINFO(font) },
	{ TAGINFO(h1) },
	{ TAGINFO(h2) },
	{ TAGINFO(h3) },
	{ TAGINFO(h4) },
	{ TAGINFO(h5) },
	{ TAGINFO(h6) },
	{ TAGINFO(address) },
	{ TAGINFO(b) },
	{ TAGINFO(i) },
	{ TAGINFO(tt) },
	{ TAGINFO(u) },
	{ TAGINFO(s) },
	{ TAGINFO(strong) },
	{ TAGINFO(em) },
	{ TAGINFO(cite) },
	{ TAGINFO(var) },
	{ TAGINFO(code) },
	{ TAGINFO(kbd) },
	{ TAGINFO(samp) },
	{ TAGINFO(blink) },
	{ TAGINFO(big) },
	{ TAGINFO(small) },
	{ TAGINFO(br) },
	{ TAGINFO(p) },
	{ TAGINFO(hr) },
	{ TAGINFO(pre) },
	{ TAGINFO(blockquote) },
	{ TAGINFO(ul) },
	{ TAGINFO(ol) },
	{ TAGINFO(menu) },
	{ TAGINFO(dir) },
	{ TAGINFO(lh)},
	{ TAGINFO(li)},
	{ TAGINFO(dl)},
	{ TAGINFO(dt)},
	{ TAGINFO(dd) },
	{ TAGINFO(div) },
	{ TAGINFO(center) },
	{ TAGINFO(a) },
	{ TAGINFO(img) },
	{ TAGINFO(form) },
	{ TAGINFO(input) },
	{ TAGINFO(select) },
	{ TAGINFO(option) },
	{ TAGINFO(textarea) },
	{ TAGINFO(table) },
	{ TAGINFO(caption) },
	{ TAGINFO(th) },
	{ TAGINFO(td) },
	{ TAGINFO(tr) },
};

typedef struct OptInfo {
	char *name,
	Options id;
} OptInfo;

static int
check_optinfo(void *p, char *str)
{
	OptInfo *t = p;
	return strcmp(t->name, str);
}

#define OPTINFO(tag) #tag,OPT_ ## tag
OptInfo optinfo_table[] = {
	{ OPTINFO(backgrond) },
	{ OPTINFO(bgcolor) },
	{ OPTINFO(text) },
	{ OPTINFO(alink) },
	{ OPTINFO(link) },
	{ OPTINFO(vlink) },
	{ OPTINFO(name) },
	{ OPTINFO(type) },
	{ OPTINFO(size) },
	{ OPTINFO(noshade) },
	{ OPTINFO(width) },
	{ OPTINFO(height) },
	{ OPTINFO(compact) },
	{ OPTINFO(href) },
	{ OPTINFO(src) },
	{ OPTINFO(lowsrc) },
	{ OPTINFO(alt) },
	{ OPTINFO(border) },
	{ OPTINFO(hspace) },
	{ OPTINFO(vspace) },
	{ OPTINFO(align) },
	{ OPTINFO(valign) },
	{ OPTINFO(method) },
	{ OPTINFO(action) },
	{ OPTINFO(value) },
	{ OPTINFO(maxlength) },
	{ OPTINFO(checed) },
	{ OPTINFO(multiple) },
	{ OPTINFO(selected) },
	{ OPTINFO(rows) },
	{ OPTINFO(cols) },
	{ OPTINFO(cellpadding) },
	{ OPTINFO(cellspacing) },
	{ OPTINFO(nowrap) },
	{ OPTINFO(rawsoan) },
	{ OPTINFO(colspan) },
	{ OPTINFO(left) },
	{ OPTINFO(center) },
	{ OPTINFO(right) },
	{ OPTINFO(top) },
	{ OPTINFO(bottom) },
	{ OPTINFO(middle) },
	{ OPTINFO(absmiddle) }
}

