#include "tag.h"

#define HASHSIZE 161
static TagInfo *hashtab[HASHSIZE];

#define TAGINFO(tag) #tag,TAG_ ## tag,
static TagInfo taginfo_table[] = {
	{ TAGINFO(h1) },
	{ TAGINFO(h2) },
	{ TAGINFO(h3) },
	{ TAGINFO(h4) },
	{ TAGINFO(h5) },
	{ TAGINFO(h6) },

	{ TAGINFO(b) },
	{ TAGINFO(i) },
	{ TAGINFO(tt) },
	{ TAGINFO(u) },
	{ TAGINFO(strike) },
	{ TAGINFO(em) },
	{ TAGINFO(strong) },
	{ TAGINFO(dfn) },
	{ TAGINFO(code) },
	{ TAGINFO(samp) },
	{ TAGINFO(kbd) },
	{ TAGINFO(var) },
	{ TAGINFO(cite) },
	{ TAGINFO(big) },
	{ TAGINFO(small) },
	{ TAGINFO(sub) },
	{ TAGINFO(sup) },
	{ TAGINFO(blink) },

	{ TAGINFO(a) },
	{ TAGINFO(img) },
	{ TAGINFO(font) },
	{ TAGINFO(basefont) },
	{ TAGINFO(br) },
	{ TAGINFO(applet) },
	{ TAGINFO(script) },
	{ TAGINFO(map) },

	{ TAGINFO(input) },
	{ TAGINFO(select) },
	{ TAGINFO(textarea) },

	{ TAGINFO(p) },
	{ TAGINFO(ul) },
	{ TAGINFO(ol) },
	{ TAGINFO(dl)},
	{ TAGINFO(menu) },
	{ TAGINFO(dir) },
	{ TAGINFO(pre) },
	{ TAGINFO(div) },
	{ TAGINFO(center) },
	{ TAGINFO(blockquote) },
	{ TAGINFO(hr) },
	{ TAGINFO(form) },
	{ TAGINFO(isindex) },
	{ TAGINFO(table) },

	{ TAGINFO(address) },

	{ TAGINFO(html) },
	{ TAGINFO(head) },
	{ TAGINFO(body) },
	{ TAGINFO(title) },
	{ TAGINFO(base)  },
	{ TAGINFO(meta)  },

	{ TAGINFO(lh)},
	{ TAGINFO(li)},
	{ TAGINFO(dt)},
	{ TAGINFO(dd) },

	{ TAGINFO(caption) },
	{ TAGINFO(th) },
	{ TAGINFO(td) },
	{ TAGINFO(tr) },

	{ NULL, 0, NULL }
};

static u_int
hash(char *s)
{
	u_int hashval;
	for (hashval = 0; *s != '\0'; s++)
        hashval = *s + 31*hashval;
    return hashval % HASHSIZE;
}

TagInfo*
GetTagInfo(char *s)
{
    TagInfo *p;
    for (p = hashtab[hash(s)]; p != NULL; p = p->next)
        if (strcmp(s, p->name) == 0)
            return p;
    return NULL;
}

void
InitTagInfo(void)
{
    TagInfo *p;
    u_int hashval;
    for (p = taginfo_table; p->name != NULL; p++) {
		hashval = hash(p->name);
		p->next = hashtab[hashval];
		hashtab[hashval] = p;
    }
} 
