#ifndef _text_h_
#define _text_h_

#include "fonts.h"

#define FONTTYPE_NORMAL     0
#define FONTTYPE_BOLD       0x01
#define FONTTYPE_ITALIC     0x02
#define	FONTTYPE_BOLDITALIC 0x03
#define FONTTYPE_PRE		0x04
#define FONTTYPE_ALL 		5

typedef struct FontDataTable {
	struct FontDataTable *next;
	wchar_t head;
	FontData *fd;
} FontDataTable, *FontDataTableList;

typedef struct OCStat {
	wchar_t *str;
	int cur;
	int len;
} OCStat;

typedef struct OC {
	FontDataTableList fdtable;
} OC;

OC* CreateOC(Display *dpy, FontInfoTableList fil,
			 XrmQuark foundry, XrmQuark name,
			 XrmQuark weight, XrmQuark slant, XrmQuark spacing, int size);

OC* CreateOC2(Display *dpy, FontInfoTableList fil, 
			  FontNameTableList fp, 
			  XrmQuark weight, XrmQuark slant, XrmQuark spacing, int size);

OC* CreateOC3(Display *dpy, 
			  FontInfoTableList fitl, 
			  FontNameTableList fntl,
			  int fonttype, int fontsize);

void DestroyOC(OC *oc);

int WcDrawString(Display*, Drawable, OC*, GC, int, int, wchar_t*, int);
int WcDrawImageString(Display*, Drawable, OC*, GC, int, int, wchar_t*, int);
int WcTextEscapement(OC *, wchar_t *, int);
void WcExtents(OC *oc, wchar_t *string, int length, XCharStruct *);
int WcWidth(OC *oc, wchar_t wc);

int gyomatsu_kinsoku(wchar_t wc);
int gyoto_kinsoku(wchar_t wc);

void text_fontinfotables_init(void);
FontInfoTableList text_get_fitl(Display *dpy);
extern FontNameTable text_font_name[];
extern FontNameTable text_font_name2[];

#endif
