#include <stdio.h>
#include <stdlib.h>

#include "timer.h"

TimerDat*
timer_new(void)
{
	TimerDat *p;
	if ((p = malloc(sizeof(*p))) == NULL) {
		perror("timer_new");
		exit(1);
	}
	p->next = NULL;
	p->data = NULL;
	p->interval = 0;
	return p;
}

void
timer_delete(TimerDat *p)
{
	if (p)
		free(p);
}

void
timerlist_delete(TimerDatList l)
{
	TimerDat *p, *q;
	if (l) {
		p = l->next;
		while (p != NULL) {
			q = p;
			p = p->next;
			timer_delete(q);
		}
		timer_delete(l);
	}
}

void
timer_reentry(TimerDatList list, void *data, TimerDat *new, int interval)
{
	TimerDat *t = list;
	
	/* search entry point */
	while (t->next != NULL) {
		if (t->next->interval > interval)
			break;
		interval -= t->next->interval;
		t = t->next;
	}
	/* ꥹȤɲ */
	new->data = data;
	new->next = t->next;
	new->interval = interval;
	if (t->next)
		t->next->interval -= interval;
	t->next = new;
}

void
timer_entry(TimerDatList list, void *data)
{
	TimerDat *new = timer_new();
	timer_reentry(list, data, new, 0);
}


