#ifndef _xmaidmsg_h_
#define _xmaidmsg_h_

#include "msgpack.h"

typedef struct XMaidMsgInfo {
	struct XMaidMsgInfo *next;

	XMaidWidget xmw;
	Widget msgbuf;
	int fd;					/* input from msgbuf */
	int fdout;				/* output to msgbuf  */
	XtInputId input_id;
	XtInputId output_id;

	/* output */
	MsgPacket *output;

	/* input */
	char *input_buf;
	int input_cur;
	int input_size;
	int inputflag;

	char *msgpath;

} XMaidMsgInfo, *XMaidMsgInfoList;

XMaidMsgInfo *xmaidmsginfo_new(XMaidWidget xmw);
void xmaidmsginfo_delete(XMaidMsgInfo *msg);
void xmaidmsginfolist_delete(XMaidMsgInfoList l);

void xmaid_msginfo_entry_string(XMaidMsgInfo *msg, char *str, int len);
void xmaid_msginfo_entry_file(XMaidMsgInfo *msg, char *name);
void xmaid_msginfo_entry_fd(XMaidMsgInfo *msg, int fd, char *name);
void xmaid_msginfo_entry_parsefile(XMaidMsgInfo *msg, char *name);

void xmaid_msginfo_open(XMaidMsgInfo *msg, Widget msgbuf);
void xmaid_msginfo_open2(XMaidWidget xmw, u_int w, u_int h, char *name);
void xmaid_msginfo_open3(XMaidWidget xmw, u_int w, u_int h, char *name);

#endif

